require("town.nut");

/* Import SuperLib for GameScript */
import("util.superlib", "SuperLib", 19);
Result <- SuperLib.Result;
Log <- SuperLib.Log;
Helper <- SuperLib.Helper;

class SyCityGrowth extends GSController 
{
	constructor() 
	{
	}
	
	towns = null;
}

function SyCityGrowth::Start() 
{
	Log.Info("Starting game setup", Log.LVL_INFO);
	GSGameSettings.SetValue("economy.fund_buildings", 0);

	// Create the towns list
	Log.Info("Create town list ...", Log.LVL_INFO);
	this.towns = this.CreateTownList();
	// Set initial time the towns will grow
	foreach (town in this.towns) {
		town.ManageTown();
	}
	Log.Info("Game setup done", Log.LVL_INFO);
	
	while (true) {
		this.ManageTowns();
		this.Sleep(1000);
		
	}
}

function SyCityGrowth::CreateTownList()
{
	local result = [];

	/* Make a squirrel array of all towns.
	 * For each town, an instance of Town is created
	 * to store the data related to that town
	 */
	local all_towns = GSTownList();
	foreach(t, _ in all_towns)
	{
		result.append(Town(t));
	}

	return result;
}

function SyCityGrowth::ManageTowns() {
	Log.Info("pax threashold: " + GSController.GetSetting("min_transport_pax"), Log.LVL_DEBUG);
	foreach (town in this.towns) {
		town.ManageTown();
	}
	Log.Info("End of Town Management.", Log.LVL_DEBUG);
}
